# -*- coding: utf-8 -*-
from setuphelpers import *

"""
[
    {
        "key": "{33ED69D3-7E88-4885-9875-6C0711368017}",
        "name": "Microsoft Windows Desktop Runtime - 7.0.14 (x64)",
        "version": "56.56.4039",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{33ED69D3-7E88-4885-9875-6C0711368017}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": true,
    },
    {
        "key": "{9C583D0D-D10B-4E33-A3A8-CD07B6DB9E2D}",
        "name": "Microsoft .NET Runtime - 7.0.14 (x64)",
        "version": "56.56.4026",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{9C583D0D-D10B-4E33-A3A8-CD07B6DB9E2D}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": true,
    },
    {
        "key": "{9C80B2AB-2F2D-45B3-A287-DDA827E3A561}",
        "name": "Microsoft .NET Host - 7.0.14 (x64)",
        "version": "56.56.4026",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{9C80B2AB-2F2D-45B3-A287-DDA827E3A561}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": true,
    },
    {
        "key": "{D8110067-D041-4061-84F4-DAB281E54EAC}",
        "name": "Microsoft .NET Host FX Resolver - 7.0.14 (x64)",
        "version": "56.56.4026",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{D8110067-D041-4061-84F4-DAB281E54EAC}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": true,
    },
    {
        "key": "{2C1104B0-76A8-44BE-B5EE-513B3E453916}",
        "name": "Microsoft Windows Desktop Runtime - 7.0.14 (x86)",
        "version": "56.56.4039",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{2C1104B0-76A8-44BE-B5EE-513B3E453916}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{2D709657-8E73-4DC2-BDB1-C12701D8A425}",
        "name": "Microsoft .NET Runtime - 7.0.14 (x86)",
        "version": "56.56.4026",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{2D709657-8E73-4DC2-BDB1-C12701D8A425}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{65668C8B-8364-423C-8BD4-E17906EFE5D7}",
        "name": "Microsoft .NET Host FX Resolver - 7.0.14 (x86)",
        "version": "56.56.4026",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{65668C8B-8364-423C-8BD4-E17906EFE5D7}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{7a903a43-d7fc-4538-8168-3a6ab10d06bb}",
        "name": "Microsoft Windows Desktop Runtime - 7.0.14 (x86)",
        "version": "7.0.14.33020",
        "install_date": "",
        "install_location": "",
        "uninstall_string": '"C:\\ProgramData\\Package Cache\\{7a903a43-d7fc-4538-8168-3a6ab10d06bb}\\windowsdesktop-runtime-7.0.14-win-x86.exe"  /uninstall',
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{7f2c8be3-7757-4594-aead-09a5112e7725}",
        "name": "Microsoft Windows Desktop Runtime - 7.0.14 (x64)",
        "version": "7.0.14.33020",
        "install_date": "",
        "install_location": "",
        "uninstall_string": '"C:\\ProgramData\\Package Cache\\{7f2c8be3-7757-4594-aead-09a5112e7725}\\windowsdesktop-runtime-7.0.14-win-x64.exe"  /uninstall',
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
    {
        "key": "{8FAFE5CB-ED93-44CB-83E3-497E87DE8673}",
        "name": "Microsoft .NET Host - 7.0.14 (x86)",
        "version": "56.56.4026",
        "install_date": "2023-11-27 00:00:00",
        "install_location": "",
        "uninstall_string": "MsiExec.exe /X{8FAFE5CB-ED93-44CB-83E3-497E87DE8673}",
        "publisher": "Microsoft Corporation",
        "system_component": 0,
        "win64": false,
    },
]


"""


def install():
    dotnet_version = control.get_software_version().split(".")[0]

    # Installing the software
    silentflags = "/install /quiet /norestart"
    if iswin64():
        install_exe_if_needed(
            glob.glob("windowsdesktop-runtime-*x64.exe")[0],
            silentflags=silentflags,
            name=f"Microsoft Windows Desktop Runtime - {dotnet_version}.*(x64)",
            min_version="",
            force=True,  # force option, since the version is not easy to check, and the installer will take care of it.
        )
    install_exe_if_needed(
        glob.glob("windowsdesktop-runtime-*x86.exe")[0],
        silentflags=silentflags,
        name=f"Microsoft Windows Desktop Runtime - {dotnet_version}.*(x86)",
        min_version="",
        force=True,  # force option, since the version is not easy to check, and the installer will take care of it.
    )

    # Clear uninstallkey to avoid the no-code audit and uninstall
    uninstallkey.clear()


def audit():
    # Declaring local variables
    audit_result = "OK"
    dotnet_version = control.get_software_version().split(".")[0]
    app_check = installed_softwares(name=f"Microsoft Windows Desktop Runtime - {dotnet_version}.*")
    audit_version = True

    # Auditing software
    if not app_check:
        print("%s is not installed" % control.package.split("-", 1)[-1].replace("-", " ").title())
        audit_result = "ERROR"
    elif audit_version:
        for to_audit in app_check:
            if r"ProgramData\Package Cache" in to_audit["uninstall_string"]:
                if Version(to_audit["version"]) < Version(control.get_software_version()):
                    print(f'{to_audit["name"]} is installed in version: {to_audit["version"]} instead of: {control.get_software_version()}.')
                    audit_result = "WARNING"
                else:
                    print("%s is installed and up-to-date." % to_audit["name"])

    return audit_result


def uninstall():
    # Declaring local variables
    dotnet_version = control.get_software_version().split(".")[0]

    for to_uninstall in installed_softwares(name=f"Microsoft Windows Desktop Runtime - {dotnet_version}.*"):
        if r"ProgramData\Package Cache" in to_uninstall["uninstall_string"]:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(ensure_list(control.impacted_process))
            run(uninstall_cmd(to_uninstall["key"]) + " /norestart")
            wait_uninstallkey_absent(to_uninstall["key"])
            if isdir(to_uninstall["install_location"]):
                remove_tree(to_uninstall["install_location"])
